function F1=tranf1(D,di,dd,emp,D_X,dc)
% compute the edge feature function 
% output the edge feature function matrixes for edges

if(isempty(D_X))

    D=1./D.^di;
    [nemp L]=size(emp);
    E=emp(1:(nemp-1),:);
    [m n]=size(D);
    for i=1:(L-1)
        E1=E(:,i)*ones(1,n);
        E2=ones(n,1)*E(:,i+1)';
        D_1=(E1+E2).*D/2;    
        D1=1./(dd*ones(1,size(D_1,1)));D2=1/(dc);
        D0=[D_1 D1';D1 D2];
        F1{i}=D0;
    end

else
  
    D=1./D.^di;
    [nemp nnodes]=size(emp);
    E=emp(1:(nemp-1),:);
    [m n]=size(D);
    [E0, Nedges] = assignEdgeNums(D_X);
    for i=1:nnodes
        for j=i+1:nnodes
            if (D_X(i,j))
                 E1=E(:,i)*ones(1,n);
                 E2=ones(n,1)*E(:,j)';
                 D_1=(E1+E2).*D/2;
                 D1=1./(dd*ones(1,size(D_1,1)));D2=1/(dc);
                 D0=[D_1 D1';D1 D2];
                 F1{E0(i,j)}=D0;
            end
        end
    end

   
end

    
